<template>
  <div
    v-if="variant === 'index'"
    class="w-full h-full flex flex-col gap-2 justify-center items-center px-6 py-4"
    :class="size === 'default' ? 'max-w-[1237px] min-h-[240px]' : 'max-w-[473px] min-h-[216px]'"
  >
    <Icon
      :icon="emptyStateIcon"
      :height="size === 'default' ? 48 : 32"
      :width="size === 'default' ? 48 : 32"
    />

    <div class="flex flex-col items-center gap-4 self-stretch">
      <div class="flex flex-col items-center gap-1 self-stretch">
        <svn-pro-title v-if="title" h6 medium class="text-center">
          {{ title }}
        </svn-pro-title>

        <p
          v-html="supportingText"
          class="text-center max-w-[608px] text-onSurfaceVariant"
          :class="size === 'default' ? 'text-body-1' : 'text-body-2'"
        />
      </div>

      <div
        v-if="actions"
        class="justify-center gap-3 hidden"
        :class="size === 'default' ? 'md:!flex' : 'md:!flex flex-col-reverse'"
      >
        <svn-pro-button
          v-if="actionSecondaryTitle"
          variant="tonal"
          color="primary"
          :prepend-icon="prependSecondary"
          :text="actionSecondaryTitle"
          @click="onClickActionTwo"
        />

        <svn-pro-button
          v-if="actionPrimaryTitle"
          variant="flat"
          color="primary"
          :prepend-icon="prependPrimary"
          :text="actionPrimaryTitle"
          @click="onClickActionOne"
        />
      </div>
    </div>
  </div>

  <div
    v-else-if="variant === 'results'"
    class="w-full h-full flex flex-col gap-2 justify-center items-center px-6 py-4"
    :class="size === 'default' ? 'max-w-[1237px] min-h-[200px]' : 'max-w-[473px] min-h-[128px]'"
  >
    <Icon
      :icon="emptyStateIcon"
      :height="size === 'default' ? 48 : 32"
      :width="size === 'default' ? 48 : 32"
    />

    <svn-pro-text
      regular
      :bodyLarge="size === 'default'"
      :bodyMedium="size === 'compact'"
      class="text-center"
      color="onSurfaceVariant"
    >
      {{ supportingText }}
    </svn-pro-text>
  </div>
</template>

<script setup>
import { Icon } from "@iconify/vue";
import SvnProText from "../../components/styles/SvnProText.vue";
import SvnProTitle from "../../components/styles/SvnProTitle.vue";
import SvnProButton from "../../components/button/SvnProButton.vue";
import { computed } from 'vue';

const props = defineProps({
  variant: {
    type: String,
    default: "index",
  },
  size: {
    type: String,
    default: "default",
  },
  title: {
    type: String,
    default: undefined,
  },
  supportingText: {
    type: String,
    default: "Write here a brief explanation: what will be found here, why it's empty (if needed) and what the User could do now/later.",
  },
  actions: {
    type: Boolean,
    default: false,
  },
  prependSecondary: {
    type: String,
    default: undefined,
  },
  prependPrimary: {
    type: String,
    default: undefined,
  },
  actionPrimaryTitle: {
    type: String,
    default: undefined,
  },
  actionSecondaryTitle: {
    type: String,
    default: undefined,
  },
  icon: {
    type: String,
    default: undefined,
  },
});

const emptyStateIcon = computed(() => {
  if (props.icon) {
    return props.icon
  } else if (props.variant === 'results') {
    return 'noto:face-with-monocle'
  } else {
    return 'noto:winking-face'
  }
})

const emits = defineEmits(['update:modelValue', 'click-primary', 'click-secondary'])

const onClickActionOne = () => {
  emits('click-primary')
}

const onClickActionTwo = () => {
  emits('click-secondary')
}
</script>